﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Facebook;
using Facebook.Web;

namespace Mvc3Website.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            if (User.Identity.IsAuthenticated)
            {
                var user = Mvc3Website.Models.InMemoryUserStore.Get(long.Parse(HttpContext.User.Identity.Name));
                FacebookClient fbClient = new FacebookClient(user.AccessToken);

                dynamic myFriends = fbClient.Get("me/friends?fields=name,id");

                return View(myFriends);
            }
            else
            {
                return View();
            }
        }

        [Authorize]
        public ActionResult FriendDetail(string id)
        {
            if (User.Identity.IsAuthenticated)
            {
                var user = Mvc3Website.Models.InMemoryUserStore.Get(long.Parse(HttpContext.User.Identity.Name));
                FacebookClient fbClient = new FacebookClient(user.AccessToken);

                dynamic detail = fbClient.Get("/" + id + "?fields=picture,name,gender");

                return View(detail);
            }
            else
            {
                return View();
            }
        }
    }
}
